<template>
  <v-menu offset-y>
    <!-- Avatar -->
    <template #activator="{ on, attrs }">
      <div class="avatar studium-navbar-link" v-bind="attrs" v-on="on">
        <!-- Image -->
        <v-avatar class="avatar-image" color="primary" size="40">
          <span class="avatar-image-initials">{{ initials }}</span>
        </v-avatar>

        <!-- Name -->
        <div class="avatar-name ml-3">
          {{ fullName }}
        </div>
      </div>
    </template>

    <!-- Menu -->
    <v-list>
      <!-- Logout -->
      <v-list-item @click="$auth.logout()">
        <v-list-item-icon>
          <v-icon color="primary">mdi-logout</v-icon>
        </v-list-item-icon>
        <v-list-item-title>Logout</v-list-item-title>
      </v-list-item>
    </v-list>
  </v-menu>
</template>

<script lang="ts">
import { computed, defineComponent, useContext } from '@nuxtjs/composition-api'

export default defineComponent({
  setup() {
    const context = useContext()

    // User full name
    const fullName = computed(() => `${context.$auth.user?.firstName} ${context.$auth.user?.lastName}`)

    // User initials
    const initials = computed(() => fullName.value.charAt(0))

    return {
      fullName,
      initials,
    }
  },
})
</script>

<style lang="scss" scoped>
.avatar {
  display: flex;
  align-items: center;
  height: 100%;
  max-width: 400px;

  &--active {
    border-bottom: 3px solid $primary;
  }

  &-image {
    &-initials {
      color: white;
      font-weight: bold;
      font-size: 1.4rem;
    }
  }

  &-name {
    font-size: 1.2rem;
  }
}
</style>
